
package com.loafle;
import static org.junit.Assert.*;

import com.loafle.overflow.crawler.snmp.SNMPCrawler;
import org.junit.Test;

import java.util.HashMap;
import java.util.Map;
import java.util.SortedSet;
import java.util.TreeSet;

public class AppTest {

    /***
     * v2c test info
     * private static String addr = "192.168.1.215";
     * private static String port = "161";
     *  private static String community = "public";
     *
     * v3 test info
     * loafle MD5 "qwer5795" DES "qweqwe123" : AUTHPRIV
     * loafle2 SHA "qwer5795" AES "qweqwe123" : AUTHPRIV
     * loafle3 MD5 "qwer5795" : AUTHNOPRIV
     * loafle4 :NOAUTHNOPRIV
     */
    @Test
    public void testSNMP() {
        SNMPCrawler c = new SNMPCrawler();
        Map config = new HashMap();

        config.put("ip", "192.168.1.215");
        config.put("port", "161");

//        config.put("version", "v2c");
//        config.put("community", "public");
//        config.put("method", "get");
//        config.put("oids", new String[]{"1.3.6.1.2.1.1.5.0", "1.3.6.1.2.1.2.2.1.6.2"});

        config.put("version", "v3");
        config.put("user", "loafle");
        config.put("authType", "MD5");
        config.put("authPass", "qwer5795");
        config.put("privType", "DES");
        config.put("privPass", "qweqwe123");
        config.put("method", "walk");
        config.put("oids", new String[]{"1.3.6.1.2.1.25.2.3.1.3"});

        Object result = c.getInternal(config);

        if(result instanceof Boolean) {
            System.out.println("validate : " + result);
        }else  {
            printResult((Map<String, String>)result);
        }

    }

    private void printResult(Map<String, String> result) {
        for (Map.Entry<String, String> entry : result.entrySet()) {
            System.out.printf("oid: %s - value: %s\n", entry.getKey(), entry.getValue());
        }

    }

}